import * as server from "@minecraft/server"

server.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent("brewinandchewin:ffpf", {
        //Делает то же самое, что и max:smoke.
        onTick: result => {
            result.block.dimension.runCommand(`execute positioned ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} run function smoke`)
        },

        //Делает то же самое, что и max:bowl.
        onPlayerInteract: result => {
            let player = result.player
            let item = player.getComponent("minecraft:equippable").getEquipment("Mainhand")

            //Если предмет в руке недействителен (нет предмета), код ниже не выполняется.
            if (!item) return

            //query.get_equipped_item_name('main_hand') == 'bowl'
            if (item.typeId == "minecraft:bowl") {

                // "set_block": {
                //     "block_type": "brewinandchewin:fiery_fondue_pot_level1"
                // },
                result.block.setType("brewinandchewin:fiery_fondue_pot_level1")

                // "spawn_loot": {
                // 	"table": "loot_tables/fiery_fondue.json"
                // },
                result.dimension.runCommand(`loot spawn ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} loot "fiery_fondue"`)

                //decrement_stack
                if (item.amount == 1)
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", undefined)
                else {
                    item.amount--
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", item)
                }
            }
        }
    })
    initEvent.blockComponentRegistry.registerCustomComponent("brewinandchewin:ffpl1", {
        //Делает то же самое, что и max:smoke.
        onTick: result => {
            result.block.dimension.runCommand(`execute positioned ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} run function smoke`)
        },

        //Делает то же самое, что и max:bowl.
        onPlayerInteract: result => {
            let player = result.player
            let item = player.getComponent("minecraft:equippable").getEquipment("Mainhand")

            //Если предмет в руке недействителен (нет предмета), код ниже не выполняется.
            if (!item) return

            //query.get_equipped_item_name('main_hand') == 'bowl'
            if (item.typeId == "minecraft:bowl") {

                // "set_block": {
                //     "block_type": "brewinandchewin:fiery_fondue_pot_level2"
                // },
                result.block.setType("brewinandchewin:fiery_fondue_pot_level2")

                // "spawn_loot": {
                // 	"table": "loot_tables/fiery_fondue.json"
                // },
                result.dimension.runCommand(`loot spawn ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} loot "fiery_fondue"`)

                //decrement_stack
                if (item.amount == 1)
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", undefined)
                else {
                    item.amount--
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", item)
                }
            }
        }
    })
    initEvent.blockComponentRegistry.registerCustomComponent("brewinandchewin:ffpl2", {
        //Делает то же самое, что и max:smoke.
        onTick: result => {
            result.block.dimension.runCommand(`execute positioned ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} run function smoke`)
        },

        //Делает то же самое, что и max:bowl.
        onPlayerInteract: result => {
            let player = result.player
            let item = player.getComponent("minecraft:equippable").getEquipment("Mainhand")

            //Если предмет в руке недействителен (нет предмета), код ниже не выполняется.
            if (!item) return

            //query.get_equipped_item_name('main_hand') == 'bowl'
            if (item.typeId == "minecraft:bowl") {

                // "set_block": {
                //     "block_type": "minecraft:cauldron"
                // },
                result.block.setType("minecraft:cauldron")

                // "spawn_loot": {
                // 	"table": "loot_tables/fiery_fondue.json"
                // },
                result.dimension.runCommand(`loot spawn ${result.block.center().x} ${result.block.center().y} ${result.block.center().z} loot "fiery_fondue_and_bone"`)

                //decrement_stack
                if (item.amount == 1)
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", undefined)
                else {
                    item.amount--
                    player.getComponent("minecraft:equippable").setEquipment("Mainhand", item)
                }
            }
        }
    })
})